#include "2d.h"
#include "stdlib.h"

/*
ɬפ0, פʾ0֤
*/
int clip_line(point2d_t *st, point2d_t *en, point2d_t lt, point2d_t rb){
    int st_code, en_code;
    double a;
    point2d_t *tmp;

    //    printf("(%d,%d)-(%d,%d)\n", st->x, st->y, en->x, en->y);
    if (st->x > en->x){
        tmp = st;
        st = en;
        en = tmp;
    }
    else if (st->x == en->x && st->y > en->y){
        tmp = st;
        st = en;
        en = tmp;
    }

    st_code = get_code(*st, lt, rb);
    en_code = get_code(*en, lt, rb);

    /* Ȥΰ */
    if ((st_code | en_code) == 0){
        return -1;
    }
    /* Ȥΰ賰Ʊ¦ˤ */
    else if ((st_code & en_code) != 0){
        return 0;
    }


    a = (double)(en->y - st->y) / (en->x - st->x);

    if (st_code & cl_left){
        st->y += (lt.x - st->x) * a;
        st->x = lt.x;
        st_code = get_code(*st, lt, rb);
    }
    if (st_code & cl_top){
        st->x += (lt.y - st->y) / a;
        st->y = lt.y;
    }
    else if (st_code & cl_bottom){
        st->x -= (st->y - rb.y) / a;
        st->y = rb.y;
    }

    if (en_code & cl_right){
        en->y -= (en->x - rb.x) * a;
        en->x = rb.x;
        en_code = get_code(*en, lt, rb);
    }
    if (en_code & cl_top){
        en->x += (lt.y - en->y) / a;
        en->y = lt.y;
    }
    else if (en_code & cl_bottom){
        en->x -= (en->y - rb.y) / a;
        en->y = rb.y;
    }

    //    printf("  (%d,%d)-(%d,%d)\n", st->x, st->y, en->x, en->y);
    /* üעʬΤΰ賰 */
    /* ǴפʤȤΤǡȤꤢᤱаפȸʤ */
    if (abs(st->x - en->x) < 2 && abs(st->y - en->y) < 2){
        return 0;
    }
    else {
        return -1;
    }
}

int get_code(point2d_t pt, point2d_t lt, point2d_t rb){
    int code = 0;
    if (pt.x < lt.x){
        code += cl_left;
    }
    else if (pt.x > rb.x){
        code += cl_right;
    }
    if (pt.y < lt.y){
        code += cl_top;
    }
    else if (pt.y > rb.y){
        code += cl_bottom;
    }
    return code;
}
